module GI.Gtk.Objects.Action where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Action = Action (ForeignPtr Action)
instance GObject Action where
class GObject o => ActionK o
instance (GObject o, IsDescendantOf Action o) => ActionK o
data ActionActionGroupPropertyInfo
data ActionAlwaysShowImagePropertyInfo
data ActionGiconPropertyInfo
data ActionHideIfEmptyPropertyInfo
data ActionIconNamePropertyInfo
data ActionIsImportantPropertyInfo
data ActionLabelPropertyInfo
data ActionNamePropertyInfo
data ActionSensitivePropertyInfo
data ActionShortLabelPropertyInfo
data ActionStockIdPropertyInfo
data ActionTooltipPropertyInfo
data ActionVisiblePropertyInfo
data ActionVisibleHorizontalPropertyInfo
data ActionVisibleOverflownPropertyInfo
data ActionVisibleVerticalPropertyInfo
data ActionActivateSignalInfo
