module GI.Gtk.Objects.Application where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Application = Application (ForeignPtr Application)
instance GObject Application where
class GObject o => ApplicationK o
instance (GObject o, IsDescendantOf Application o) => ApplicationK o
data ApplicationActiveWindowPropertyInfo
data ApplicationAppMenuPropertyInfo
data ApplicationMenubarPropertyInfo
data ApplicationRegisterSessionPropertyInfo
data ApplicationWindowAddedSignalInfo
data ApplicationWindowRemovedSignalInfo
