module GI.Gtk.Objects.Image where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Image = Image (ForeignPtr Image)
instance GObject Image where
class GObject o => ImageK o
instance (GObject o, IsDescendantOf Image o) => ImageK o
data ImageFilePropertyInfo
data ImageGiconPropertyInfo
data ImageIconNamePropertyInfo
data ImageIconSetPropertyInfo
data ImageIconSizePropertyInfo
data ImagePixbufPropertyInfo
data ImagePixbufAnimationPropertyInfo
data ImagePixelSizePropertyInfo
data ImageResourcePropertyInfo
data ImageStockPropertyInfo
data ImageStorageTypePropertyInfo
data ImageSurfacePropertyInfo
data ImageUseFallbackPropertyInfo
