module GI.Gtk.Objects.Notebook where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Notebook = Notebook (ForeignPtr Notebook)
instance GObject Notebook where
class GObject o => NotebookK o
instance (GObject o, IsDescendantOf Notebook o) => NotebookK o
data NotebookEnablePopupPropertyInfo
data NotebookGroupNamePropertyInfo
data NotebookPagePropertyInfo
data NotebookScrollablePropertyInfo
data NotebookShowBorderPropertyInfo
data NotebookShowTabsPropertyInfo
data NotebookTabPosPropertyInfo
data NotebookChangeCurrentPageSignalInfo
data NotebookCreateWindowSignalInfo
data NotebookFocusTabSignalInfo
data NotebookMoveFocusOutSignalInfo
data NotebookPageAddedSignalInfo
data NotebookPageRemovedSignalInfo
data NotebookPageReorderedSignalInfo
data NotebookReorderTabSignalInfo
data NotebookSelectPageSignalInfo
data NotebookSwitchPageSignalInfo
