module GI.Gtk.Objects.TextBuffer where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype TextBuffer = TextBuffer (ForeignPtr TextBuffer)
instance GObject TextBuffer where
class GObject o => TextBufferK o
instance (GObject o, IsDescendantOf TextBuffer o) => TextBufferK o
data TextBufferCopyTargetListPropertyInfo
data TextBufferCursorPositionPropertyInfo
data TextBufferHasSelectionPropertyInfo
data TextBufferPasteTargetListPropertyInfo
data TextBufferTagTablePropertyInfo
data TextBufferTextPropertyInfo
data TextBufferApplyTagSignalInfo
data TextBufferBeginUserActionSignalInfo
data TextBufferChangedSignalInfo
data TextBufferDeleteRangeSignalInfo
data TextBufferEndUserActionSignalInfo
data TextBufferInsertChildAnchorSignalInfo
data TextBufferInsertPixbufSignalInfo
data TextBufferInsertTextSignalInfo
data TextBufferMarkDeletedSignalInfo
data TextBufferMarkSetSignalInfo
data TextBufferModifiedChangedSignalInfo
data TextBufferPasteDoneSignalInfo
data TextBufferRemoveTagSignalInfo
