module GI.Gtk.Objects.TextTag where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype TextTag = TextTag (ForeignPtr TextTag)
instance GObject TextTag where
class GObject o => TextTagK o
instance (GObject o, IsDescendantOf TextTag o) => TextTagK o
data TextTagAccumulativeMarginPropertyInfo
data TextTagBackgroundPropertyInfo
data TextTagBackgroundFullHeightPropertyInfo
data TextTagBackgroundFullHeightSetPropertyInfo
data TextTagBackgroundGdkPropertyInfo
data TextTagBackgroundRgbaPropertyInfo
data TextTagBackgroundSetPropertyInfo
data TextTagDirectionPropertyInfo
data TextTagEditablePropertyInfo
data TextTagEditableSetPropertyInfo
data TextTagFallbackPropertyInfo
data TextTagFallbackSetPropertyInfo
data TextTagFamilyPropertyInfo
data TextTagFamilySetPropertyInfo
data TextTagFontPropertyInfo
data TextTagFontDescPropertyInfo
data TextTagFontFeaturesPropertyInfo
data TextTagFontFeaturesSetPropertyInfo
data TextTagForegroundPropertyInfo
data TextTagForegroundGdkPropertyInfo
data TextTagForegroundRgbaPropertyInfo
data TextTagForegroundSetPropertyInfo
data TextTagIndentPropertyInfo
data TextTagIndentSetPropertyInfo
data TextTagInvisiblePropertyInfo
data TextTagInvisibleSetPropertyInfo
data TextTagJustificationPropertyInfo
data TextTagJustificationSetPropertyInfo
data TextTagLanguagePropertyInfo
data TextTagLanguageSetPropertyInfo
data TextTagLeftMarginPropertyInfo
data TextTagLeftMarginSetPropertyInfo
data TextTagLetterSpacingPropertyInfo
data TextTagLetterSpacingSetPropertyInfo
data TextTagNamePropertyInfo
data TextTagParagraphBackgroundPropertyInfo
data TextTagParagraphBackgroundGdkPropertyInfo
data TextTagParagraphBackgroundRgbaPropertyInfo
data TextTagParagraphBackgroundSetPropertyInfo
data TextTagPixelsAboveLinesPropertyInfo
data TextTagPixelsAboveLinesSetPropertyInfo
data TextTagPixelsBelowLinesPropertyInfo
data TextTagPixelsBelowLinesSetPropertyInfo
data TextTagPixelsInsideWrapPropertyInfo
data TextTagPixelsInsideWrapSetPropertyInfo
data TextTagRightMarginPropertyInfo
data TextTagRightMarginSetPropertyInfo
data TextTagRisePropertyInfo
data TextTagRiseSetPropertyInfo
data TextTagScalePropertyInfo
data TextTagScaleSetPropertyInfo
data TextTagSizePropertyInfo
data TextTagSizePointsPropertyInfo
data TextTagSizeSetPropertyInfo
data TextTagStretchPropertyInfo
data TextTagStretchSetPropertyInfo
data TextTagStrikethroughPropertyInfo
data TextTagStrikethroughRgbaPropertyInfo
data TextTagStrikethroughRgbaSetPropertyInfo
data TextTagStrikethroughSetPropertyInfo
data TextTagStylePropertyInfo
data TextTagStyleSetPropertyInfo
data TextTagTabsPropertyInfo
data TextTagTabsSetPropertyInfo
data TextTagUnderlinePropertyInfo
data TextTagUnderlineRgbaPropertyInfo
data TextTagUnderlineRgbaSetPropertyInfo
data TextTagUnderlineSetPropertyInfo
data TextTagVariantPropertyInfo
data TextTagVariantSetPropertyInfo
data TextTagWeightPropertyInfo
data TextTagWeightSetPropertyInfo
data TextTagWrapModePropertyInfo
data TextTagWrapModeSetPropertyInfo
data TextTagEventSignalInfo
