module GI.Gtk.Objects.Toolbar where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Toolbar = Toolbar (ForeignPtr Toolbar)
instance GObject Toolbar where
class GObject o => ToolbarK o
instance (GObject o, IsDescendantOf Toolbar o) => ToolbarK o
data ToolbarIconSizePropertyInfo
data ToolbarIconSizeSetPropertyInfo
data ToolbarShowArrowPropertyInfo
data ToolbarToolbarStylePropertyInfo
data ToolbarFocusHomeOrEndSignalInfo
data ToolbarOrientationChangedSignalInfo
data ToolbarPopupContextMenuSignalInfo
data ToolbarStyleChangedSignalInfo
