module GI.Gtk.Objects.TreeView where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype TreeView = TreeView (ForeignPtr TreeView)
instance GObject TreeView where
class GObject o => TreeViewK o
instance (GObject o, IsDescendantOf TreeView o) => TreeViewK o
data TreeViewActivateOnSingleClickPropertyInfo
data TreeViewEnableGridLinesPropertyInfo
data TreeViewEnableSearchPropertyInfo
data TreeViewEnableTreeLinesPropertyInfo
data TreeViewExpanderColumnPropertyInfo
data TreeViewFixedHeightModePropertyInfo
data TreeViewHeadersClickablePropertyInfo
data TreeViewHeadersVisiblePropertyInfo
data TreeViewHoverExpandPropertyInfo
data TreeViewHoverSelectionPropertyInfo
data TreeViewLevelIndentationPropertyInfo
data TreeViewModelPropertyInfo
data TreeViewReorderablePropertyInfo
data TreeViewRubberBandingPropertyInfo
data TreeViewRulesHintPropertyInfo
data TreeViewSearchColumnPropertyInfo
data TreeViewShowExpandersPropertyInfo
data TreeViewTooltipColumnPropertyInfo
data TreeViewColumnsChangedSignalInfo
data TreeViewCursorChangedSignalInfo
data TreeViewExpandCollapseCursorRowSignalInfo
data TreeViewMoveCursorSignalInfo
data TreeViewRowActivatedSignalInfo
data TreeViewRowCollapsedSignalInfo
data TreeViewRowExpandedSignalInfo
data TreeViewSelectAllSignalInfo
data TreeViewSelectCursorParentSignalInfo
data TreeViewSelectCursorRowSignalInfo
data TreeViewStartInteractiveSearchSignalInfo
data TreeViewTestCollapseRowSignalInfo
data TreeViewTestExpandRowSignalInfo
data TreeViewToggleCursorRowSignalInfo
data TreeViewUnselectAllSignalInfo
