module GI.Gtk.Objects.UIManager where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype UIManager = UIManager (ForeignPtr UIManager)
instance GObject UIManager where
class GObject o => UIManagerK o
instance (GObject o, IsDescendantOf UIManager o) => UIManagerK o
data UIManagerAddTearoffsPropertyInfo
data UIManagerUiPropertyInfo
data UIManagerActionsChangedSignalInfo
data UIManagerAddWidgetSignalInfo
data UIManagerConnectProxySignalInfo
data UIManagerDisconnectProxySignalInfo
data UIManagerPostActivateSignalInfo
data UIManagerPreActivateSignalInfo
