module GI.Gtk.Objects.Window where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Window = Window (ForeignPtr Window)
instance GObject Window where
class GObject o => WindowK o
instance (GObject o, IsDescendantOf Window o) => WindowK o
data WindowAcceptFocusPropertyInfo
data WindowApplicationPropertyInfo
data WindowAttachedToPropertyInfo
data WindowDecoratedPropertyInfo
data WindowDefaultHeightPropertyInfo
data WindowDefaultWidthPropertyInfo
data WindowDeletablePropertyInfo
data WindowDestroyWithParentPropertyInfo
data WindowFocusOnMapPropertyInfo
data WindowFocusVisiblePropertyInfo
data WindowGravityPropertyInfo
data WindowHasResizeGripPropertyInfo
data WindowHasToplevelFocusPropertyInfo
data WindowHideTitlebarWhenMaximizedPropertyInfo
data WindowIconPropertyInfo
data WindowIconNamePropertyInfo
data WindowIsActivePropertyInfo
data WindowIsMaximizedPropertyInfo
data WindowMnemonicsVisiblePropertyInfo
data WindowModalPropertyInfo
data WindowResizablePropertyInfo
data WindowResizeGripVisiblePropertyInfo
data WindowRolePropertyInfo
data WindowScreenPropertyInfo
data WindowSkipPagerHintPropertyInfo
data WindowSkipTaskbarHintPropertyInfo
data WindowStartupIdPropertyInfo
data WindowTitlePropertyInfo
data WindowTransientForPropertyInfo
data WindowTypePropertyInfo
data WindowTypeHintPropertyInfo
data WindowUrgencyHintPropertyInfo
data WindowWindowPositionPropertyInfo
data WindowActivateDefaultSignalInfo
data WindowActivateFocusSignalInfo
data WindowEnableDebuggingSignalInfo
data WindowKeysChangedSignalInfo
data WindowSetFocusSignalInfo
