
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Structs.ThemeEngine
    ( 

-- * Exported types
    ThemeEngine(..)                         ,
    noThemeEngine                           ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype ThemeEngine = ThemeEngine (ForeignPtr ThemeEngine)
noThemeEngine :: Maybe ThemeEngine
noThemeEngine = Nothing


