module GI.Gtk.Objects.CellRenderer where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype CellRenderer = CellRenderer (ForeignPtr CellRenderer)
instance GObject CellRenderer where
class GObject o => CellRendererK o
instance (GObject o, IsDescendantOf CellRenderer o) => CellRendererK o
data CellRendererCellBackgroundPropertyInfo
data CellRendererCellBackgroundGdkPropertyInfo
data CellRendererCellBackgroundRgbaPropertyInfo
data CellRendererCellBackgroundSetPropertyInfo
data CellRendererEditingPropertyInfo
data CellRendererHeightPropertyInfo
data CellRendererIsExpandedPropertyInfo
data CellRendererIsExpanderPropertyInfo
data CellRendererModePropertyInfo
data CellRendererSensitivePropertyInfo
data CellRendererVisiblePropertyInfo
data CellRendererWidthPropertyInfo
data CellRendererXalignPropertyInfo
data CellRendererXpadPropertyInfo
data CellRendererYalignPropertyInfo
data CellRendererYpadPropertyInfo
data CellRendererEditingCanceledSignalInfo
data CellRendererEditingStartedSignalInfo
