module GI.Gtk.Objects.ComboBox where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype ComboBox = ComboBox (ForeignPtr ComboBox)
instance GObject ComboBox where
class GObject o => ComboBoxK o
instance (GObject o, IsDescendantOf ComboBox o) => ComboBoxK o
data ComboBoxActivePropertyInfo
data ComboBoxActiveIdPropertyInfo
data ComboBoxAddTearoffsPropertyInfo
data ComboBoxButtonSensitivityPropertyInfo
data ComboBoxCellAreaPropertyInfo
data ComboBoxColumnSpanColumnPropertyInfo
data ComboBoxEntryTextColumnPropertyInfo
data ComboBoxFocusOnClickPropertyInfo
data ComboBoxHasEntryPropertyInfo
data ComboBoxHasFramePropertyInfo
data ComboBoxIdColumnPropertyInfo
data ComboBoxModelPropertyInfo
data ComboBoxPopupFixedWidthPropertyInfo
data ComboBoxPopupShownPropertyInfo
data ComboBoxRowSpanColumnPropertyInfo
data ComboBoxTearoffTitlePropertyInfo
data ComboBoxWrapWidthPropertyInfo
data ComboBoxChangedSignalInfo
data ComboBoxFormatEntryTextSignalInfo
data ComboBoxMoveActiveSignalInfo
data ComboBoxPopdownSignalInfo
data ComboBoxPopupSignalInfo
