module GI.Gtk.Objects.Container where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Container = Container (ForeignPtr Container)
instance GObject Container where
class GObject o => ContainerK o
instance (GObject o, IsDescendantOf Container o) => ContainerK o
data ContainerBorderWidthPropertyInfo
data ContainerChildPropertyInfo
data ContainerResizeModePropertyInfo
data ContainerAddSignalInfo
data ContainerCheckResizeSignalInfo
data ContainerRemoveSignalInfo
data ContainerSetFocusChildSignalInfo
