module GI.Gtk.Objects.PrintOperation where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype PrintOperation = PrintOperation (ForeignPtr PrintOperation)
instance GObject PrintOperation where
class GObject o => PrintOperationK o
instance (GObject o, IsDescendantOf PrintOperation o) => PrintOperationK o
data PrintOperationAllowAsyncPropertyInfo
data PrintOperationCurrentPagePropertyInfo
data PrintOperationCustomTabLabelPropertyInfo
data PrintOperationDefaultPageSetupPropertyInfo
data PrintOperationEmbedPageSetupPropertyInfo
data PrintOperationExportFilenamePropertyInfo
data PrintOperationHasSelectionPropertyInfo
data PrintOperationJobNamePropertyInfo
data PrintOperationNPagesPropertyInfo
data PrintOperationNPagesToPrintPropertyInfo
data PrintOperationPrintSettingsPropertyInfo
data PrintOperationShowProgressPropertyInfo
data PrintOperationStatusPropertyInfo
data PrintOperationStatusStringPropertyInfo
data PrintOperationSupportSelectionPropertyInfo
data PrintOperationTrackPrintStatusPropertyInfo
data PrintOperationUnitPropertyInfo
data PrintOperationUseFullPagePropertyInfo
data PrintOperationBeginPrintSignalInfo
data PrintOperationCreateCustomWidgetSignalInfo
data PrintOperationCustomWidgetApplySignalInfo
data PrintOperationDoneSignalInfo
data PrintOperationDrawPageSignalInfo
data PrintOperationEndPrintSignalInfo
data PrintOperationPaginateSignalInfo
data PrintOperationPreviewSignalInfo
data PrintOperationRequestPageSetupSignalInfo
data PrintOperationStatusChangedSignalInfo
data PrintOperationUpdateCustomWidgetSignalInfo
