module GI.Gtk.Objects.ScrolledWindow where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype ScrolledWindow = ScrolledWindow (ForeignPtr ScrolledWindow)
instance GObject ScrolledWindow where
class GObject o => ScrolledWindowK o
instance (GObject o, IsDescendantOf ScrolledWindow o) => ScrolledWindowK o
data ScrolledWindowHadjustmentPropertyInfo
data ScrolledWindowHscrollbarPolicyPropertyInfo
data ScrolledWindowKineticScrollingPropertyInfo
data ScrolledWindowMinContentHeightPropertyInfo
data ScrolledWindowMinContentWidthPropertyInfo
data ScrolledWindowOverlayScrollingPropertyInfo
data ScrolledWindowShadowTypePropertyInfo
data ScrolledWindowVadjustmentPropertyInfo
data ScrolledWindowVscrollbarPolicyPropertyInfo
data ScrolledWindowWindowPlacementPropertyInfo
data ScrolledWindowWindowPlacementSetPropertyInfo
data ScrolledWindowEdgeOvershotSignalInfo
data ScrolledWindowEdgeReachedSignalInfo
data ScrolledWindowMoveFocusOutSignalInfo
data ScrolledWindowScrollChildSignalInfo
