module GI.Gtk.Objects.TextView where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype TextView = TextView (ForeignPtr TextView)
instance GObject TextView where
class GObject o => TextViewK o
instance (GObject o, IsDescendantOf TextView o) => TextViewK o
data TextViewAcceptsTabPropertyInfo
data TextViewBottomMarginPropertyInfo
data TextViewBufferPropertyInfo
data TextViewCursorVisiblePropertyInfo
data TextViewEditablePropertyInfo
data TextViewImModulePropertyInfo
data TextViewIndentPropertyInfo
data TextViewInputHintsPropertyInfo
data TextViewInputPurposePropertyInfo
data TextViewJustificationPropertyInfo
data TextViewLeftMarginPropertyInfo
data TextViewMonospacePropertyInfo
data TextViewOverwritePropertyInfo
data TextViewPixelsAboveLinesPropertyInfo
data TextViewPixelsBelowLinesPropertyInfo
data TextViewPixelsInsideWrapPropertyInfo
data TextViewPopulateAllPropertyInfo
data TextViewRightMarginPropertyInfo
data TextViewTabsPropertyInfo
data TextViewTopMarginPropertyInfo
data TextViewWrapModePropertyInfo
data TextViewBackspaceSignalInfo
data TextViewCopyClipboardSignalInfo
data TextViewCutClipboardSignalInfo
data TextViewDeleteFromCursorSignalInfo
data TextViewExtendSelectionSignalInfo
data TextViewInsertAtCursorSignalInfo
data TextViewMoveCursorSignalInfo
data TextViewMoveViewportSignalInfo
data TextViewPasteClipboardSignalInfo
data TextViewPopulatePopupSignalInfo
data TextViewPreeditChangedSignalInfo
data TextViewSelectAllSignalInfo
data TextViewSetAnchorSignalInfo
data TextViewToggleCursorVisibleSignalInfo
data TextViewToggleOverwriteSignalInfo
