module GI.Gtk.Objects.Widget where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype Widget = Widget (ForeignPtr Widget)
instance GObject Widget where
class GObject o => WidgetK o
instance (GObject o, IsDescendantOf Widget o) => WidgetK o
data WidgetAppPaintablePropertyInfo
data WidgetCanDefaultPropertyInfo
data WidgetCanFocusPropertyInfo
data WidgetCompositeChildPropertyInfo
data WidgetDoubleBufferedPropertyInfo
data WidgetEventsPropertyInfo
data WidgetExpandPropertyInfo
data WidgetHalignPropertyInfo
data WidgetHasDefaultPropertyInfo
data WidgetHasFocusPropertyInfo
data WidgetHasTooltipPropertyInfo
data WidgetHeightRequestPropertyInfo
data WidgetHexpandPropertyInfo
data WidgetHexpandSetPropertyInfo
data WidgetIsFocusPropertyInfo
data WidgetMarginPropertyInfo
data WidgetMarginBottomPropertyInfo
data WidgetMarginEndPropertyInfo
data WidgetMarginLeftPropertyInfo
data WidgetMarginRightPropertyInfo
data WidgetMarginStartPropertyInfo
data WidgetMarginTopPropertyInfo
data WidgetNamePropertyInfo
data WidgetNoShowAllPropertyInfo
data WidgetOpacityPropertyInfo
data WidgetParentPropertyInfo
data WidgetReceivesDefaultPropertyInfo
data WidgetScaleFactorPropertyInfo
data WidgetSensitivePropertyInfo
data WidgetStylePropertyInfo
data WidgetTooltipMarkupPropertyInfo
data WidgetTooltipTextPropertyInfo
data WidgetValignPropertyInfo
data WidgetVexpandPropertyInfo
data WidgetVexpandSetPropertyInfo
data WidgetVisiblePropertyInfo
data WidgetWidthRequestPropertyInfo
data WidgetWindowPropertyInfo
data WidgetAccelClosuresChangedSignalInfo
data WidgetButtonPressEventSignalInfo
data WidgetButtonReleaseEventSignalInfo
data WidgetCanActivateAccelSignalInfo
data WidgetChildNotifySignalInfo
data WidgetCompositedChangedSignalInfo
data WidgetConfigureEventSignalInfo
data WidgetDamageEventSignalInfo
data WidgetDeleteEventSignalInfo
data WidgetDestroySignalInfo
data WidgetDestroyEventSignalInfo
data WidgetDirectionChangedSignalInfo
data WidgetDragBeginSignalInfo
data WidgetDragDataDeleteSignalInfo
data WidgetDragDataGetSignalInfo
data WidgetDragDataReceivedSignalInfo
data WidgetDragDropSignalInfo
data WidgetDragEndSignalInfo
data WidgetDragFailedSignalInfo
data WidgetDragLeaveSignalInfo
data WidgetDragMotionSignalInfo
data WidgetDrawSignalInfo
data WidgetEnterNotifyEventSignalInfo
data WidgetEventSignalInfo
data WidgetEventAfterSignalInfo
data WidgetFocusSignalInfo
data WidgetFocusInEventSignalInfo
data WidgetFocusOutEventSignalInfo
data WidgetGrabBrokenEventSignalInfo
data WidgetGrabFocusSignalInfo
data WidgetGrabNotifySignalInfo
data WidgetHideSignalInfo
data WidgetHierarchyChangedSignalInfo
data WidgetKeyPressEventSignalInfo
data WidgetKeyReleaseEventSignalInfo
data WidgetKeynavFailedSignalInfo
data WidgetLeaveNotifyEventSignalInfo
data WidgetMapSignalInfo
data WidgetMapEventSignalInfo
data WidgetMnemonicActivateSignalInfo
data WidgetMotionNotifyEventSignalInfo
data WidgetMoveFocusSignalInfo
data WidgetParentSetSignalInfo
data WidgetPopupMenuSignalInfo
data WidgetPropertyNotifyEventSignalInfo
data WidgetProximityInEventSignalInfo
data WidgetProximityOutEventSignalInfo
data WidgetQueryTooltipSignalInfo
data WidgetRealizeSignalInfo
data WidgetScreenChangedSignalInfo
data WidgetScrollEventSignalInfo
data WidgetSelectionClearEventSignalInfo
data WidgetSelectionGetSignalInfo
data WidgetSelectionNotifyEventSignalInfo
data WidgetSelectionReceivedSignalInfo
data WidgetSelectionRequestEventSignalInfo
data WidgetShowSignalInfo
data WidgetShowHelpSignalInfo
data WidgetSizeAllocateSignalInfo
data WidgetStateChangedSignalInfo
data WidgetStateFlagsChangedSignalInfo
data WidgetStyleSetSignalInfo
data WidgetStyleUpdatedSignalInfo
data WidgetTouchEventSignalInfo
data WidgetUnmapSignalInfo
data WidgetUnmapEventSignalInfo
data WidgetUnrealizeSignalInfo
data WidgetVisibilityNotifyEventSignalInfo
data WidgetWindowStateEventSignalInfo
