
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Gtk.Structs.TextBTree
    ( 

-- * Exported types
    TextBTree(..)                           ,
    noTextBTree                             ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gtk.Types
import GI.Gtk.Callbacks

newtype TextBTree = TextBTree (ForeignPtr TextBTree)
noTextBTree :: Maybe TextBTree
noTextBTree = Nothing


